// ..................................................................
//
//                          AppsDemo
//
//              Copyright  1998 by Martin Djerns
//
// ..................................................................
// This code shall show how to use the TmdApps and TmdTrayApps.
// There is only one (Tray-)demo, but that also shows most of the
// functionallity.
//
// Please notice that the classes is thourght as base classes for
// FORMLESS projects, so therefore the whole idea is gone if you
// include "forms" in you project.
// ..................................................................
//
// Feel free to copy distribute this file, but remember from where
// it comes, and that it do not run without the unit mdApps.pas
// which is a freeware unit written for and by me ;-)
//
// ..................................................................
// Contact : Martin Djerns <martin@djernaes.dk>
// Web     : http://www.djernaes.dk/martin
// Smile...
// ..................................................................
program AppsDemo;

uses
  Windows,
  Messages,
  mdApps;

{$R *.RES}
{$R SecondIcon.res}  // I want to use two icons ;-)

Const
  MI_CLOSE = WM_USER+1;
  MI_ABOUT = WM_USER+2;

Type
  TApp = class(TmdTrayApp)
  Protected
    Procedure miClose(Var Msg : TMessage); Message MI_CLOSE;
    Procedure miAbout(Var Msg : TMessage); Message MI_ABOUT;
    Procedure OnDefault; Override;
    Procedure OnSimple; Override;
  Public
    Constructor Create(Const Name : String); Override;
  end;

Constructor TApp.Create(Const Name : String);
Begin
  Inherited Create(Name);
  AddMenuItem('&Close',MI_CLOSE,[]);  // Close
  AddMenuItem('-',0,[]);              // -----
  AddMenuItem('&About',MI_ABOUT,[msDefault]);
end;

Procedure TApp.miClose(Var Msg : TMessage);
Begin
  Close;
end;

Procedure TApp.miAbout(Var Msg : TMessage);
Begin
  OnDefault;
end;

Procedure TApp.OnDefault;
Begin
  MessageBox(Handle,
             'AppsDemo is Copyright  1998 by Martin Djerns',
             'AppsDemo',
             MB_OK OR MB_ICONINFORMATION)
end;

Procedure TApp.OnSimple;
Begin
  IconHandle := LoadIcon(HInstance,'SECONDICON');
  UpdateTray;
end;

begin
  With TApp.Create('AppsDemo') do
  Try
    Run;
  Finally
    Free;
  end;
end.
